//+------------------------------------------------------------------+
//|                                               KeltnerChannel.mq4 |
//|                                                  Coded by Gilani |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//|-- Modified by TradingSytemForex, http://www.tradingsystemforex.com

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Lime
#property indicator_color3 Lime
#property indicator_color4 Magenta
#property indicator_color5 Magenta
#property indicator_color6 Magenta

double upperU[], middleU[], lowerU[];
double upperD[], middleD[], lowerD[];
extern int     MA_PERIOD = 20;
extern int     MA_MODE = 0;
extern int     PRICE_MODE = 5;
extern int     ATR_PERIOD = 50;
extern double  K = 2.0;
extern bool    ATR_MODE = false;

int init()
  {  
   SetIndexStyle(0,DRAW_LINE, EMPTY, 2);
   SetIndexShift(0,0);
   SetIndexDrawBegin(0,0);
   SetIndexBuffer(0,upperU);

   SetIndexStyle(1,DRAW_LINE,STYLE_DOT, 2);
   SetIndexShift(1,0);
   SetIndexDrawBegin(1,0);
   SetIndexBuffer(1,middleU);

   SetIndexStyle(2,DRAW_LINE, EMPTY, 2);
   SetIndexShift(2,0);
   SetIndexDrawBegin(2,0);
   SetIndexBuffer(2,lowerU);
   
   SetIndexStyle(3,DRAW_LINE, EMPTY, 2);
   SetIndexShift(3,0);
   SetIndexDrawBegin(3,0);
   SetIndexBuffer(3,upperD);

   SetIndexStyle(4,DRAW_LINE,STYLE_DOT, 2);
   SetIndexShift(4,0);
   SetIndexDrawBegin(4,0);
   SetIndexBuffer(4,middleD);

   SetIndexStyle(5,DRAW_LINE, EMPTY, 2);
   SetIndexShift(5,0);
   SetIndexDrawBegin(5,0);
   SetIndexBuffer(5,lowerD);
    

//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   double avg;
   
   for(int x=0; x<limit; x++) {
      
      if (ATR_MODE)
      avg  = iATR(NULL,0,ATR_PERIOD, x);
      else 
      avg  = findAvg(ATR_PERIOD, x);
      
      if(iMA(NULL, 0, MA_PERIOD, 0, MA_MODE, PRICE_MODE, x)>=iMA(NULL, 0, MA_PERIOD, 0, MA_MODE, PRICE_MODE, x+1))
      {
         middleU[x]=iMA(NULL, 0, MA_PERIOD, 0, MA_MODE, PRICE_MODE, x);
         upperU[x]=iMA(NULL, 0, MA_PERIOD, 0, MA_MODE, PRICE_MODE, x) + K*avg;
         lowerU[x]=iMA(NULL, 0, MA_PERIOD, 0, MA_MODE, PRICE_MODE, x) - K*avg;
         middleD[x]=EMPTY_VALUE;
         upperD[x]=EMPTY_VALUE;
         lowerD[x]=EMPTY_VALUE;
      }
      
      if(iMA(NULL, 0, MA_PERIOD, 0, MA_MODE, PRICE_MODE, x)<iMA(NULL, 0, MA_PERIOD, 0, MA_MODE, PRICE_MODE, x+1))
      {
         middleU[x]=EMPTY_VALUE;
         upperU[x]=EMPTY_VALUE;
         lowerU[x]=EMPTY_VALUE;
         middleD[x]=iMA(NULL, 0, MA_PERIOD, 0, MA_MODE, PRICE_MODE, x);
         upperD[x]=iMA(NULL, 0, MA_PERIOD, 0, MA_MODE, PRICE_MODE, x) + K*avg;
         lowerD[x]=iMA(NULL, 0, MA_PERIOD, 0, MA_MODE, PRICE_MODE, x) - K*avg;
      }
      
   }
   return(0);
  }
//+------------------------------------------------------------------+


   double findAvg(int period, int shift) {
      double sum=0;
      for (int x=shift;x<(shift+period);x++) {     
         sum += High[x]-Low[x];
      }
      sum = sum/period;
      return (sum);
   }